# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyCacheKeyPolicy do
  @moduledoc """
  Message containing what to include in the cache key for a request for Cloud CDN.

  ## Attributes

  *   `includeHttpHeaders` (*type:* `list(String.t)`, *default:* `nil`) - Allows HTTP request headers (by name) to be used in the cache key.
  *   `queryStringWhitelist` (*type:* `list(String.t)`, *default:* `nil`) - Names of query string parameters to include in cache keys. Default parameters are always included. '&' and '=' will be percent encoded and not treated as delimiters.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :includeHttpHeaders => list(String.t()) | nil,
          :queryStringWhitelist => list(String.t()) | nil
        }

  field(:includeHttpHeaders, type: :list)
  field(:queryStringWhitelist, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyCacheKeyPolicy do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyCacheKeyPolicy.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyCacheKeyPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
