# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyNegativeCachingPolicy do
  @moduledoc """
  Specify CDN TTLs for response error codes.

  ## Attributes

  *   `code` (*type:* `integer()`, *default:* `nil`) - The HTTP status code to define a TTL against. Only HTTP status codes 300, 301, 302, 307, 308, 404, 405, 410, 421, 451 and 501 are can be specified as values, and you cannot specify a status code more than once.
  *   `ttl` (*type:* `integer()`, *default:* `nil`) - The TTL (in seconds) for which to cache responses with the corresponding status code. The maximum allowed value is 1800s (30 minutes), noting that infrequently accessed objects may be evicted from the cache before the defined TTL.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :code => integer() | nil,
          :ttl => integer() | nil
        }

  field(:code)
  field(:ttl)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyNegativeCachingPolicy do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyNegativeCachingPolicy.decode(value, options)
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyNegativeCachingPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
