# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.BackendServiceGroupHealth do
  @moduledoc """


  ## Attributes

  *   `annotations` (*type:* `map()`, *default:* `nil`) - Metadata defined as annotations on the network endpoint group.
  *   `healthStatus` (*type:* `list(GoogleApi.Compute.V1.Model.HealthStatus.t)`, *default:* `nil`) - Health state of the backend instances or endpoints in requested instance or network endpoint group, determined based on configured health checks.
  *   `kind` (*type:* `String.t`, *default:* `compute#backendServiceGroupHealth`) - [Output Only] Type of resource. Always compute#backendServiceGroupHealth for the health of backend services.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :annotations => map() | nil,
          :healthStatus => list(GoogleApi.Compute.V1.Model.HealthStatus.t()) | nil,
          :kind => String.t() | nil
        }

  field(:annotations, type: :map)
  field(:healthStatus, as: GoogleApi.Compute.V1.Model.HealthStatus, type: :list)
  field(:kind)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.BackendServiceGroupHealth do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.BackendServiceGroupHealth.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.BackendServiceGroupHealth do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
