# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfig do
  @moduledoc """
  Container for either a built-in LB policy supported by gRPC or Envoy or a custom one implemented by the end user.

  ## Attributes

  *   `customPolicy` (*type:* `GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.t`, *default:* `nil`) - 
  *   `policy` (*type:* `GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfigPolicy.t`, *default:* `nil`) - 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :customPolicy =>
            GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.t()
            | nil,
          :policy =>
            GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfigPolicy.t()
            | nil
        }

  field(:customPolicy,
    as: GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
  )

  field(:policy,
    as: GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
  )
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfig do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfig.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
