# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy do
  @moduledoc """
  The configuration for a custom policy implemented by the user and deployed with the client.

  ## Attributes

  *   `data` (*type:* `String.t`, *default:* `nil`) - An optional, arbitrary JSON object with configuration data, understood by a locally installed custom policy implementation.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Identifies the custom policy. The value should match the name of a custom implementation registered on the gRPC clients. It should follow protocol buffer message naming conventions and include the full path (for example, myorg.CustomLbPolicy). The maximum length is 256 characters. Do not specify the same custom policy more than once for a backend. If you do, the configuration is rejected. For an example of how to use this field, see Use a custom policy.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :data => String.t() | nil,
          :name => String.t() | nil
        }

  field(:data)
  field(:name)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
