# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.BulkInsertInstanceResourcePerInstanceProperties do
  @moduledoc """
  Per-instance properties to be set on individual instances. To be extended in the future.

  ## Attributes

  *   `hostname` (*type:* `String.t`, *default:* `nil`) - Specifies the hostname of the instance. More details in: https://cloud.google.com/compute/docs/instances/custom-hostname-vm#naming_convention
  *   `name` (*type:* `String.t`, *default:* `nil`) - This field is only temporary. It will be removed. Do not use it.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :hostname => String.t() | nil,
          :name => String.t() | nil
        }

  field(:hostname)
  field(:name)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.BulkInsertInstanceResourcePerInstanceProperties do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.BulkInsertInstanceResourcePerInstanceProperties.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.BulkInsertInstanceResourcePerInstanceProperties do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
