# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.BulkInsertOperationStatus do
  @moduledoc """


  ## Attributes

  *   `createdVmCount` (*type:* `integer()`, *default:* `nil`) - [Output Only] Count of VMs successfully created so far.
  *   `deletedVmCount` (*type:* `integer()`, *default:* `nil`) - [Output Only] Count of VMs that got deleted during rollback.
  *   `failedToCreateVmCount` (*type:* `integer()`, *default:* `nil`) - [Output Only] Count of VMs that started creating but encountered an error.
  *   `status` (*type:* `String.t`, *default:* `nil`) - [Output Only] Creation status of BulkInsert operation - information if the flow is rolling forward or rolling back.
  *   `targetVmCount` (*type:* `integer()`, *default:* `nil`) - [Output Only] Count of VMs originally planned to be created.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :createdVmCount => integer() | nil,
          :deletedVmCount => integer() | nil,
          :failedToCreateVmCount => integer() | nil,
          :status => String.t() | nil,
          :targetVmCount => integer() | nil
        }

  field(:createdVmCount)
  field(:deletedVmCount)
  field(:failedToCreateVmCount)
  field(:status)
  field(:targetVmCount)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.BulkInsertOperationStatus do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.BulkInsertOperationStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.BulkInsertOperationStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
