# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ConsistentHashLoadBalancerSettingsHttpCookie do
  @moduledoc """
  The information about the HTTP Cookie on which the hash function is based for load balancing policies that use a consistent hash.

  ## Attributes

  *   `name` (*type:* `String.t`, *default:* `nil`) - Name of the cookie.
  *   `path` (*type:* `String.t`, *default:* `nil`) - Path to set for the cookie.
  *   `ttl` (*type:* `GoogleApi.Compute.V1.Model.Duration.t`, *default:* `nil`) - Lifetime of the cookie.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :name => String.t() | nil,
          :path => String.t() | nil,
          :ttl => GoogleApi.Compute.V1.Model.Duration.t() | nil
        }

  field(:name)
  field(:path)
  field(:ttl, as: GoogleApi.Compute.V1.Model.Duration)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.ConsistentHashLoadBalancerSettingsHttpCookie do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ConsistentHashLoadBalancerSettingsHttpCookie.decode(value, options)
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.ConsistentHashLoadBalancerSettingsHttpCookie do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
