# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.DisksStartAsyncReplicationRequest do
  @moduledoc """


  ## Attributes

  *   `asyncSecondaryDisk` (*type:* `String.t`, *default:* `nil`) - The secondary disk to start asynchronous replication to. You can provide this as a partial or full URL to the resource. For example, the following are valid values: - https://www.googleapis.com/compute/v1/projects/project/zones/zone /disks/disk - https://www.googleapis.com/compute/v1/projects/project/regions/region /disks/disk - projects/project/zones/zone/disks/disk - projects/project/regions/region/disks/disk - zones/zone/disks/disk - regions/region/disks/disk 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :asyncSecondaryDisk => String.t() | nil
        }

  field(:asyncSecondaryDisk)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.DisksStartAsyncReplicationRequest do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.DisksStartAsyncReplicationRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.DisksStartAsyncReplicationRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
