# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.DisksStopGroupAsyncReplicationResource do
  @moduledoc """
  A transient resource used in compute.disks.stopGroupAsyncReplication and compute.regionDisks.stopGroupAsyncReplication. It is only used to process requests and is not persisted.

  ## Attributes

  *   `resourcePolicy` (*type:* `String.t`, *default:* `nil`) - The URL of the DiskConsistencyGroupPolicy for the group of disks to stop. This may be a full or partial URL, such as: - https://www.googleapis.com/compute/v1/projects/project/regions/region /resourcePolicies/resourcePolicy - projects/project/regions/region/resourcePolicies/resourcePolicy - regions/region/resourcePolicies/resourcePolicy 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :resourcePolicy => String.t() | nil
        }

  field(:resourcePolicy)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.DisksStopGroupAsyncReplicationResource do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.DisksStopGroupAsyncReplicationResource.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.DisksStopGroupAsyncReplicationResource do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
