# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.FirewallPolicyAssociation do
  @moduledoc """


  ## Attributes

  *   `attachmentTarget` (*type:* `String.t`, *default:* `nil`) - The target that the firewall policy is attached to.
  *   `displayName` (*type:* `String.t`, *default:* `nil`) - [Output Only] Deprecated, please use short name instead. The display name of the firewall policy of the association.
  *   `firewallPolicyId` (*type:* `String.t`, *default:* `nil`) - [Output Only] The firewall policy ID of the association.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The name for an association.
  *   `shortName` (*type:* `String.t`, *default:* `nil`) - [Output Only] The short name of the firewall policy of the association.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :attachmentTarget => String.t() | nil,
          :displayName => String.t() | nil,
          :firewallPolicyId => String.t() | nil,
          :name => String.t() | nil,
          :shortName => String.t() | nil
        }

  field(:attachmentTarget)
  field(:displayName)
  field(:firewallPolicyId)
  field(:name)
  field(:shortName)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.FirewallPolicyAssociation do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.FirewallPolicyAssociation.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.FirewallPolicyAssociation do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
