# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ForwardingRuleServiceDirectoryRegistration do
  @moduledoc """
  Describes the auto-registration of the forwarding rule to Service Directory. The region and project of the Service Directory resource generated from this registration will be the same as this forwarding rule.

  ## Attributes

  *   `namespace` (*type:* `String.t`, *default:* `nil`) - Service Directory namespace to register the forwarding rule under.
  *   `service` (*type:* `String.t`, *default:* `nil`) - Service Directory service to register the forwarding rule under.
  *   `serviceDirectoryRegion` (*type:* `String.t`, *default:* `nil`) - [Optional] Service Directory region to register this global forwarding rule under. Default to "us-central1". Only used for PSC for Google APIs. All PSC for Google APIs forwarding rules on the same network should use the same Service Directory region.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :namespace => String.t() | nil,
          :service => String.t() | nil,
          :serviceDirectoryRegion => String.t() | nil
        }

  field(:namespace)
  field(:service)
  field(:serviceDirectoryRegion)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.ForwardingRuleServiceDirectoryRegistration do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ForwardingRuleServiceDirectoryRegistration.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.ForwardingRuleServiceDirectoryRegistration do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
