# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.Help do
  @moduledoc """
  Provides links to documentation or for performing an out of band action. For example, if a quota check failed with an error indicating the calling project hasn't enabled the accessed service, this can contain a URL pointing directly to the right place in the developer console to flip the bit.

  ## Attributes

  *   `links` (*type:* `list(GoogleApi.Compute.V1.Model.HelpLink.t)`, *default:* `nil`) - URL(s) pointing to additional information on handling the current error.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :links => list(GoogleApi.Compute.V1.Model.HelpLink.t()) | nil
        }

  field(:links, as: GoogleApi.Compute.V1.Model.HelpLink, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.Help do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.Help.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.Help do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
