# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.InstanceManagedByIgmError do
  @moduledoc """


  ## Attributes

  *   `error` (*type:* `GoogleApi.Compute.V1.Model.InstanceManagedByIgmErrorManagedInstanceError.t`, *default:* `nil`) - [Output Only] Contents of the error.
  *   `instanceActionDetails` (*type:* `GoogleApi.Compute.V1.Model.InstanceManagedByIgmErrorInstanceActionDetails.t`, *default:* `nil`) - [Output Only] Details of the instance action that triggered this error. May be null, if the error was not caused by an action on an instance. This field is optional.
  *   `timestamp` (*type:* `String.t`, *default:* `nil`) - [Output Only] The time that this error occurred. This value is in RFC3339 text format.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :error =>
            GoogleApi.Compute.V1.Model.InstanceManagedByIgmErrorManagedInstanceError.t() | nil,
          :instanceActionDetails =>
            GoogleApi.Compute.V1.Model.InstanceManagedByIgmErrorInstanceActionDetails.t() | nil,
          :timestamp => String.t() | nil
        }

  field(:error, as: GoogleApi.Compute.V1.Model.InstanceManagedByIgmErrorManagedInstanceError)

  field(:instanceActionDetails,
    as: GoogleApi.Compute.V1.Model.InstanceManagedByIgmErrorInstanceActionDetails
  )

  field(:timestamp)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.InstanceManagedByIgmError do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.InstanceManagedByIgmError.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.InstanceManagedByIgmError do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
