# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.InstanceWithNamedPorts do
  @moduledoc """


  ## Attributes

  *   `instance` (*type:* `String.t`, *default:* `nil`) - [Output Only] The URL of the instance.
  *   `namedPorts` (*type:* `list(GoogleApi.Compute.V1.Model.NamedPort.t)`, *default:* `nil`) - [Output Only] The named ports that belong to this instance group.
  *   `status` (*type:* `String.t`, *default:* `nil`) - [Output Only] The status of the instance.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :instance => String.t() | nil,
          :namedPorts => list(GoogleApi.Compute.V1.Model.NamedPort.t()) | nil,
          :status => String.t() | nil
        }

  field(:instance)
  field(:namedPorts, as: GoogleApi.Compute.V1.Model.NamedPort, type: :list)
  field(:status)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.InstanceWithNamedPorts do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.InstanceWithNamedPorts.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.InstanceWithNamedPorts do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
