# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.InstancesSetSecurityPolicyRequest do
  @moduledoc """


  ## Attributes

  *   `networkInterfaces` (*type:* `list(String.t)`, *default:* `nil`) - The network interfaces that the security policy will be applied to. Network interfaces use the nicN naming format. You can only set a security policy for network interfaces with an access config.
  *   `securityPolicy` (*type:* `String.t`, *default:* `nil`) - A full or partial URL to a security policy to add to this instance. If this field is set to an empty string it will remove the associated security policy.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :networkInterfaces => list(String.t()) | nil,
          :securityPolicy => String.t() | nil
        }

  field(:networkInterfaces, type: :list)
  field(:securityPolicy)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.InstancesSetSecurityPolicyRequest do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.InstancesSetSecurityPolicyRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.InstancesSetSecurityPolicyRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
