# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.InterconnectAttachmentPartnerMetadata do
  @moduledoc """
  Informational metadata about Partner attachments from Partners to display to customers. These fields are propagated from PARTNER_PROVIDER attachments to their corresponding PARTNER attachments.

  ## Attributes

  *   `interconnectName` (*type:* `String.t`, *default:* `nil`) - Plain text name of the Interconnect this attachment is connected to, as displayed in the Partner's portal. For instance "Chicago 1". This value may be validated to match approved Partner values.
  *   `partnerName` (*type:* `String.t`, *default:* `nil`) - Plain text name of the Partner providing this attachment. This value may be validated to match approved Partner values.
  *   `portalUrl` (*type:* `String.t`, *default:* `nil`) - URL of the Partner's portal for this Attachment. Partners may customise this to be a deep link to the specific resource on the Partner portal. This value may be validated to match approved Partner values.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :interconnectName => String.t() | nil,
          :partnerName => String.t() | nil,
          :portalUrl => String.t() | nil
        }

  field(:interconnectName)
  field(:partnerName)
  field(:portalUrl)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.InterconnectAttachmentPartnerMetadata do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.InterconnectAttachmentPartnerMetadata.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.InterconnectAttachmentPartnerMetadata do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
