# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkStatus do
  @moduledoc """


  ## Attributes

  *   `arpCaches` (*type:* `list(GoogleApi.Compute.V1.Model.InterconnectDiagnosticsARPEntry.t)`, *default:* `nil`) - A list of InterconnectDiagnostics.ARPEntry objects, describing the ARP neighbor entries seen on this link. This will be empty if the link is bundled
  *   `circuitId` (*type:* `String.t`, *default:* `nil`) - The unique ID for this link assigned during turn up by Google.
  *   `googleDemarc` (*type:* `String.t`, *default:* `nil`) - The Demarc address assigned by Google and provided in the LoA.
  *   `lacpStatus` (*type:* `GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkLACPStatus.t`, *default:* `nil`) - 
  *   `macsec` (*type:* `GoogleApi.Compute.V1.Model.InterconnectDiagnosticsMacsecStatus.t`, *default:* `nil`) - Describes the status of MACsec encryption on this link.
  *   `operationalStatus` (*type:* `String.t`, *default:* `nil`) - The operational status of the link.
  *   `receivingOpticalPower` (*type:* `GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkOpticalPower.t`, *default:* `nil`) - An InterconnectDiagnostics.LinkOpticalPower object, describing the current value and status of the received light level.
  *   `transmittingOpticalPower` (*type:* `GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkOpticalPower.t`, *default:* `nil`) - An InterconnectDiagnostics.LinkOpticalPower object, describing the current value and status of the transmitted light level.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :arpCaches =>
            list(GoogleApi.Compute.V1.Model.InterconnectDiagnosticsARPEntry.t()) | nil,
          :circuitId => String.t() | nil,
          :googleDemarc => String.t() | nil,
          :lacpStatus =>
            GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkLACPStatus.t() | nil,
          :macsec => GoogleApi.Compute.V1.Model.InterconnectDiagnosticsMacsecStatus.t() | nil,
          :operationalStatus => String.t() | nil,
          :receivingOpticalPower =>
            GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkOpticalPower.t() | nil,
          :transmittingOpticalPower =>
            GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkOpticalPower.t() | nil
        }

  field(:arpCaches, as: GoogleApi.Compute.V1.Model.InterconnectDiagnosticsARPEntry, type: :list)
  field(:circuitId)
  field(:googleDemarc)
  field(:lacpStatus, as: GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkLACPStatus)
  field(:macsec, as: GoogleApi.Compute.V1.Model.InterconnectDiagnosticsMacsecStatus)
  field(:operationalStatus)

  field(:receivingOpticalPower,
    as: GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkOpticalPower
  )

  field(:transmittingOpticalPower,
    as: GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkOpticalPower
  )
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkStatus do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.InterconnectDiagnosticsLinkStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
