# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.InterconnectDiagnosticsMacsecStatus do
  @moduledoc """
  Describes the status of MACsec encryption on the link.

  ## Attributes

  *   `ckn` (*type:* `String.t`, *default:* `nil`) - Indicates the Connectivity Association Key Name (CKN) currently being used if MACsec is operational.
  *   `operational` (*type:* `boolean()`, *default:* `nil`) - Indicates whether or not MACsec is operational on this link.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :ckn => String.t() | nil,
          :operational => boolean() | nil
        }

  field(:ckn)
  field(:operational)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.InterconnectDiagnosticsMacsecStatus do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.InterconnectDiagnosticsMacsecStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.InterconnectDiagnosticsMacsecStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
