# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.InterconnectMacsecConfigPreSharedKey do
  @moduledoc """
  Describes a pre-shared key used to setup MACsec in static connectivity association key (CAK) mode.

  ## Attributes

  *   `cak` (*type:* `String.t`, *default:* `nil`) - An auto-generated Connectivity Association Key (CAK) for this key.
  *   `ckn` (*type:* `String.t`, *default:* `nil`) - An auto-generated Connectivity Association Key Name (CKN) for this key.
  *   `name` (*type:* `String.t`, *default:* `nil`) - User provided name for this pre-shared key.
  *   `startTime` (*type:* `String.t`, *default:* `nil`) - User provided timestamp on or after which this key is valid.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cak => String.t() | nil,
          :ckn => String.t() | nil,
          :name => String.t() | nil,
          :startTime => String.t() | nil
        }

  field(:cak)
  field(:ckn)
  field(:name)
  field(:startTime)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.InterconnectMacsecConfigPreSharedKey do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.InterconnectMacsecConfigPreSharedKey.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.InterconnectMacsecConfigPreSharedKey do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
