# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.LocalizedMessage do
  @moduledoc """
  Provides a localized error message that is safe to return to the user which can be attached to an RPC error.

  ## Attributes

  *   `locale` (*type:* `String.t`, *default:* `nil`) - The locale used following the specification defined at https://www.rfc-editor.org/rfc/bcp/bcp47.txt. Examples are: "en-US", "fr-CH", "es-MX"
  *   `message` (*type:* `String.t`, *default:* `nil`) - The localized error message in the above locale.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :locale => String.t() | nil,
          :message => String.t() | nil
        }

  field(:locale)
  field(:message)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.LocalizedMessage do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.LocalizedMessage.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.LocalizedMessage do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
