# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.LocationPolicyLocation do
  @moduledoc """


  ## Attributes

  *   `constraints` (*type:* `GoogleApi.Compute.V1.Model.LocationPolicyLocationConstraints.t`, *default:* `nil`) - Constraints that the caller requires on the result distribution in this zone.
  *   `preference` (*type:* `String.t`, *default:* `nil`) - Preference for a given location. Set to either ALLOW or DENY.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :constraints => GoogleApi.Compute.V1.Model.LocationPolicyLocationConstraints.t() | nil,
          :preference => String.t() | nil
        }

  field(:constraints, as: GoogleApi.Compute.V1.Model.LocationPolicyLocationConstraints)
  field(:preference)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.LocationPolicyLocation do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.LocationPolicyLocation.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.LocationPolicyLocation do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
