# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.NatIpInfo do
  @moduledoc """
  Contains NAT IP information of a NAT config (i.e. usage status, mode).

  ## Attributes

  *   `natIpInfoMappings` (*type:* `list(GoogleApi.Compute.V1.Model.NatIpInfoNatIpInfoMapping.t)`, *default:* `nil`) - A list of all NAT IPs assigned to this NAT config.
  *   `natName` (*type:* `String.t`, *default:* `nil`) - Name of the NAT config which the NAT IP belongs to.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :natIpInfoMappings =>
            list(GoogleApi.Compute.V1.Model.NatIpInfoNatIpInfoMapping.t()) | nil,
          :natName => String.t() | nil
        }

  field(:natIpInfoMappings, as: GoogleApi.Compute.V1.Model.NatIpInfoNatIpInfoMapping, type: :list)
  field(:natName)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.NatIpInfo do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.NatIpInfo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.NatIpInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
