# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.PreservedState do
  @moduledoc """
  Preserved state for a given instance.

  ## Attributes

  *   `disks` (*type:* `%{optional(String.t) => GoogleApi.Compute.V1.Model.PreservedStatePreservedDisk.t}`, *default:* `nil`) - Preserved disks defined for this instance. This map is keyed with the device names of the disks.
  *   `externalIPs` (*type:* `%{optional(String.t) => GoogleApi.Compute.V1.Model.PreservedStatePreservedNetworkIp.t}`, *default:* `nil`) - Preserved external IPs defined for this instance. This map is keyed with the name of the network interface.
  *   `internalIPs` (*type:* `%{optional(String.t) => GoogleApi.Compute.V1.Model.PreservedStatePreservedNetworkIp.t}`, *default:* `nil`) - Preserved internal IPs defined for this instance. This map is keyed with the name of the network interface.
  *   `metadata` (*type:* `map()`, *default:* `nil`) - Preserved metadata defined for this instance.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :disks =>
            %{optional(String.t()) => GoogleApi.Compute.V1.Model.PreservedStatePreservedDisk.t()}
            | nil,
          :externalIPs =>
            %{
              optional(String.t()) =>
                GoogleApi.Compute.V1.Model.PreservedStatePreservedNetworkIp.t()
            }
            | nil,
          :internalIPs =>
            %{
              optional(String.t()) =>
                GoogleApi.Compute.V1.Model.PreservedStatePreservedNetworkIp.t()
            }
            | nil,
          :metadata => map() | nil
        }

  field(:disks, as: GoogleApi.Compute.V1.Model.PreservedStatePreservedDisk, type: :map)
  field(:externalIPs, as: GoogleApi.Compute.V1.Model.PreservedStatePreservedNetworkIp, type: :map)
  field(:internalIPs, as: GoogleApi.Compute.V1.Model.PreservedStatePreservedNetworkIp, type: :map)
  field(:metadata, type: :map)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.PreservedState do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.PreservedState.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.PreservedState do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
