# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicyRetentionPolicy do
  @moduledoc """
  Policy for retention of scheduled snapshots.

  ## Attributes

  *   `maxRetentionDays` (*type:* `integer()`, *default:* `nil`) - Maximum age of the snapshot that is allowed to be kept.
  *   `onSourceDiskDelete` (*type:* `String.t`, *default:* `nil`) - Specifies the behavior to apply to scheduled snapshots when the source disk is deleted.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :maxRetentionDays => integer() | nil,
          :onSourceDiskDelete => String.t() | nil
        }

  field(:maxRetentionDays)
  field(:onSourceDiskDelete)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicyRetentionPolicy do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicyRetentionPolicy.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicyRetentionPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
