# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicySchedule do
  @moduledoc """
  A schedule for disks where the schedueled operations are performed.

  ## Attributes

  *   `dailySchedule` (*type:* `GoogleApi.Compute.V1.Model.ResourcePolicyDailyCycle.t`, *default:* `nil`) - 
  *   `hourlySchedule` (*type:* `GoogleApi.Compute.V1.Model.ResourcePolicyHourlyCycle.t`, *default:* `nil`) - 
  *   `weeklySchedule` (*type:* `GoogleApi.Compute.V1.Model.ResourcePolicyWeeklyCycle.t`, *default:* `nil`) - 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :dailySchedule => GoogleApi.Compute.V1.Model.ResourcePolicyDailyCycle.t() | nil,
          :hourlySchedule => GoogleApi.Compute.V1.Model.ResourcePolicyHourlyCycle.t() | nil,
          :weeklySchedule => GoogleApi.Compute.V1.Model.ResourcePolicyWeeklyCycle.t() | nil
        }

  field(:dailySchedule, as: GoogleApi.Compute.V1.Model.ResourcePolicyDailyCycle)
  field(:hourlySchedule, as: GoogleApi.Compute.V1.Model.ResourcePolicyHourlyCycle)
  field(:weeklySchedule, as: GoogleApi.Compute.V1.Model.ResourcePolicyWeeklyCycle)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicySchedule do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicySchedule.decode(value, options)
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicySchedule do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
