# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicySnapshotProperties do
  @moduledoc """
  Specified snapshot properties for scheduled snapshots created by this policy.

  ## Attributes

  *   `chainName` (*type:* `String.t`, *default:* `nil`) - Chain name that the snapshot is created in.
  *   `guestFlush` (*type:* `boolean()`, *default:* `nil`) - Indication to perform a 'guest aware' snapshot.
  *   `labels` (*type:* `map()`, *default:* `nil`) - Labels to apply to scheduled snapshots. These can be later modified by the setLabels method. Label values may be empty.
  *   `storageLocations` (*type:* `list(String.t)`, *default:* `nil`) - Cloud Storage bucket storage location of the auto snapshot (regional or multi-regional).
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :chainName => String.t() | nil,
          :guestFlush => boolean() | nil,
          :labels => map() | nil,
          :storageLocations => list(String.t()) | nil
        }

  field(:chainName)
  field(:guestFlush)
  field(:labels, type: :map)
  field(:storageLocations, type: :list)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicySnapshotProperties do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicySnapshotProperties.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.ResourcePolicySnapshotSchedulePolicySnapshotProperties do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
