# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.RouteAsPath do
  @moduledoc """


  ## Attributes

  *   `asLists` (*type:* `list(integer())`, *default:* `nil`) - [Output Only] The AS numbers of the AS Path.
  *   `pathSegmentType` (*type:* `String.t`, *default:* `nil`) - [Output Only] The type of the AS Path, which can be one of the following values: - 'AS_SET': unordered set of autonomous systems that the route in has traversed - 'AS_SEQUENCE': ordered set of autonomous systems that the route has traversed - 'AS_CONFED_SEQUENCE': ordered set of Member Autonomous Systems in the local confederation that the route has traversed - 'AS_CONFED_SET': unordered set of Member Autonomous Systems in the local confederation that the route has traversed 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :asLists => list(integer()) | nil,
          :pathSegmentType => String.t() | nil
        }

  field(:asLists, type: :list)
  field(:pathSegmentType)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.RouteAsPath do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.RouteAsPath.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.RouteAsPath do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
