# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.Screenshot do
  @moduledoc """
  An instance's screenshot.

  ## Attributes

  *   `contents` (*type:* `String.t`, *default:* `nil`) - [Output Only] The Base64-encoded screenshot data.
  *   `kind` (*type:* `String.t`, *default:* `compute#screenshot`) - [Output Only] Type of the resource. Always compute#screenshot for the screenshots.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :contents => String.t() | nil,
          :kind => String.t() | nil
        }

  field(:contents)
  field(:kind)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.Screenshot do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.Screenshot.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.Screenshot do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
