# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.SecurityPolicyAdvancedOptionsConfig do
  @moduledoc """


  ## Attributes

  *   `jsonCustomConfig` (*type:* `GoogleApi.Compute.V1.Model.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.t`, *default:* `nil`) - Custom configuration to apply the JSON parsing. Only applicable when json_parsing is set to STANDARD.
  *   `jsonParsing` (*type:* `String.t`, *default:* `nil`) - 
  *   `logLevel` (*type:* `String.t`, *default:* `nil`) - 
  *   `userIpRequestHeaders` (*type:* `list(String.t)`, *default:* `nil`) - An optional list of case-insensitive request header names to use for resolving the callers client IP address.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :jsonCustomConfig =>
            GoogleApi.Compute.V1.Model.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.t()
            | nil,
          :jsonParsing => String.t() | nil,
          :logLevel => String.t() | nil,
          :userIpRequestHeaders => list(String.t()) | nil
        }

  field(:jsonCustomConfig,
    as: GoogleApi.Compute.V1.Model.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
  )

  field(:jsonParsing)
  field(:logLevel)
  field(:userIpRequestHeaders, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.SecurityPolicyAdvancedOptionsConfig do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.SecurityPolicyAdvancedOptionsConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.SecurityPolicyAdvancedOptionsConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
