# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.SecurityPolicyRuleMatcherExprOptions do
  @moduledoc """


  ## Attributes

  *   `recaptchaOptions` (*type:* `GoogleApi.Compute.V1.Model.SecurityPolicyRuleMatcherExprOptionsRecaptchaOptions.t`, *default:* `nil`) - reCAPTCHA configuration options to be applied for the rule. If the rule does not evaluate reCAPTCHA tokens, this field has no effect.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :recaptchaOptions =>
            GoogleApi.Compute.V1.Model.SecurityPolicyRuleMatcherExprOptionsRecaptchaOptions.t()
            | nil
        }

  field(:recaptchaOptions,
    as: GoogleApi.Compute.V1.Model.SecurityPolicyRuleMatcherExprOptionsRecaptchaOptions
  )
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.SecurityPolicyRuleMatcherExprOptions do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.SecurityPolicyRuleMatcherExprOptions.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.SecurityPolicyRuleMatcherExprOptions do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
