# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.SecurityPolicyRuleNetworkMatcherUserDefinedFieldMatch do
  @moduledoc """


  ## Attributes

  *   `name` (*type:* `String.t`, *default:* `nil`) - Name of the user-defined field, as given in the definition.
  *   `values` (*type:* `list(String.t)`, *default:* `nil`) - Matching values of the field. Each element can be a 32-bit unsigned decimal or hexadecimal (starting with "0x") number (e.g. "64") or range (e.g. "0x400-0x7ff").
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :name => String.t() | nil,
          :values => list(String.t()) | nil
        }

  field(:name)
  field(:values, type: :list)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.SecurityPolicyRuleNetworkMatcherUserDefinedFieldMatch do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.SecurityPolicyRuleNetworkMatcherUserDefinedFieldMatch.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.SecurityPolicyRuleNetworkMatcherUserDefinedFieldMatch do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
