# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadata do
  @moduledoc """


  ## Attributes

  *   `clientOperationId` (*type:* `String.t`, *default:* `nil`) - [Output Only] The client operation id.
  *   `perLocationOperations` (*type:* `%{optional(String.t) => GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.t}`, *default:* `nil`) - [Output Only] Status information per location (location name is key). Example key: zones/us-central1-a
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :clientOperationId => String.t() | nil,
          :perLocationOperations =>
            %{
              optional(String.t()) =>
                GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.t()
            }
            | nil
        }

  field(:clientOperationId)

  field(:perLocationOperations,
    as:
      GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo,
    type: :map
  )
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadata do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadata.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadata do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
