# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo do
  @moduledoc """


  ## Attributes

  *   `error` (*type:* `GoogleApi.Compute.V1.Model.Status.t`, *default:* `nil`) - [Output Only] If state is `ABANDONED` or `FAILED`, this field is populated.
  *   `state` (*type:* `String.t`, *default:* `nil`) - [Output Only] Status of the action, which can be one of the following: `PROPAGATING`, `PROPAGATED`, `ABANDONED`, `FAILED`, or `DONE`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :error => GoogleApi.Compute.V1.Model.Status.t() | nil,
          :state => String.t() | nil
        }

  field(:error, as: GoogleApi.Compute.V1.Model.Status)
  field(:state)
end

defimpl Poison.Decoder,
  for:
    GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for:
    GoogleApi.Compute.V1.Model.SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
