# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.TargetPoolsScopedList do
  @moduledoc """


  ## Attributes

  *   `targetPools` (*type:* `list(GoogleApi.Compute.V1.Model.TargetPool.t)`, *default:* `nil`) - A list of target pools contained in this scope.
  *   `warning` (*type:* `GoogleApi.Compute.V1.Model.TargetPoolsScopedListWarning.t`, *default:* `nil`) - Informational warning which replaces the list of addresses when the list is empty.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :targetPools => list(GoogleApi.Compute.V1.Model.TargetPool.t()) | nil,
          :warning => GoogleApi.Compute.V1.Model.TargetPoolsScopedListWarning.t() | nil
        }

  field(:targetPools, as: GoogleApi.Compute.V1.Model.TargetPool, type: :list)
  field(:warning, as: GoogleApi.Compute.V1.Model.TargetPoolsScopedListWarning)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.TargetPoolsScopedList do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.TargetPoolsScopedList.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.TargetPoolsScopedList do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
