# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.UpcomingMaintenance do
  @moduledoc """
  Upcoming Maintenance notification information.

  ## Attributes

  *   `canReschedule` (*type:* `boolean()`, *default:* `nil`) - Indicates if the maintenance can be customer triggered.
  *   `latestWindowStartTime` (*type:* `String.t`, *default:* `nil`) - The latest time for the planned maintenance window to start. This timestamp value is in RFC3339 text format.
  *   `maintenanceStatus` (*type:* `String.t`, *default:* `nil`) - 
  *   `type` (*type:* `String.t`, *default:* `nil`) - Defines the type of maintenance.
  *   `windowEndTime` (*type:* `String.t`, *default:* `nil`) - The time by which the maintenance disruption will be completed. This timestamp value is in RFC3339 text format.
  *   `windowStartTime` (*type:* `String.t`, *default:* `nil`) - The current start time of the maintenance window. This timestamp value is in RFC3339 text format.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :canReschedule => boolean() | nil,
          :latestWindowStartTime => String.t() | nil,
          :maintenanceStatus => String.t() | nil,
          :type => String.t() | nil,
          :windowEndTime => String.t() | nil,
          :windowStartTime => String.t() | nil
        }

  field(:canReschedule)
  field(:latestWindowStartTime)
  field(:maintenanceStatus)
  field(:type)
  field(:windowEndTime)
  field(:windowStartTime)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.UpcomingMaintenance do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.UpcomingMaintenance.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.UpcomingMaintenance do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
