# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.UrlRewrite do
  @moduledoc """
  The spec for modifying the path before sending the request to the matched backend service.

  ## Attributes

  *   `hostRewrite` (*type:* `String.t`, *default:* `nil`) - Before forwarding the request to the selected service, the request's host header is replaced with contents of hostRewrite. The value must be from 1 to 255 characters.
  *   `pathPrefixRewrite` (*type:* `String.t`, *default:* `nil`) - Before forwarding the request to the selected backend service, the matching portion of the request's path is replaced by pathPrefixRewrite. The value must be from 1 to 1024 characters.
  *   `pathTemplateRewrite` (*type:* `String.t`, *default:* `nil`) -  If specified, the pattern rewrites the URL path (based on the :path header) using the HTTP template syntax. A corresponding path_template_match must be specified. Any template variables must exist in the path_template_match field. - -At least one variable must be specified in the path_template_match field - You can omit variables from the rewritten URL - The * and ** operators cannot be matched unless they have a corresponding variable name - e.g. {format=*} or {var=**}. For example, a path_template_match of /static/{format=**} could be rewritten as /static/content/{format} to prefix /content to the URL. Variables can also be re-ordered in a rewrite, so that /{country}/{format}/{suffix=**} can be rewritten as /content/{format}/{country}/{suffix}. At least one non-empty routeRules[].matchRules[].path_template_match is required. Only one of path_prefix_rewrite or path_template_rewrite may be specified.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :hostRewrite => String.t() | nil,
          :pathPrefixRewrite => String.t() | nil,
          :pathTemplateRewrite => String.t() | nil
        }

  field(:hostRewrite)
  field(:pathPrefixRewrite)
  field(:pathTemplateRewrite)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.UrlRewrite do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.UrlRewrite.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.UrlRewrite do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
