# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.VmEndpointNatMappings do
  @moduledoc """
  Contain information of Nat mapping for a VM endpoint (i.e., NIC).

  ## Attributes

  *   `instanceName` (*type:* `String.t`, *default:* `nil`) - Name of the VM instance which the endpoint belongs to
  *   `interfaceNatMappings` (*type:* `list(GoogleApi.Compute.V1.Model.VmEndpointNatMappingsInterfaceNatMappings.t)`, *default:* `nil`) - 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :instanceName => String.t() | nil,
          :interfaceNatMappings =>
            list(GoogleApi.Compute.V1.Model.VmEndpointNatMappingsInterfaceNatMappings.t()) | nil
        }

  field(:instanceName)

  field(:interfaceNatMappings,
    as: GoogleApi.Compute.V1.Model.VmEndpointNatMappingsInterfaceNatMappings,
    type: :list
  )
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.VmEndpointNatMappings do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.VmEndpointNatMappings.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.VmEndpointNatMappings do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
