# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.XpnResourceId do
  @moduledoc """
  Service resource (a.k.a service project) ID.

  ## Attributes

  *   `id` (*type:* `String.t`, *default:* `nil`) - The ID of the service resource. In the case of projects, this field supports project id (e.g., my-project-123) and project number (e.g. 12345678).
  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of the service resource.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :id => String.t() | nil,
          :type => String.t() | nil
        }

  field(:id)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.XpnResourceId do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.XpnResourceId.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.XpnResourceId do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
